#!/bin/bash
## Simply script to make sure that every entry in PASSWD is synced
## with every user or site and that every user has an entry in the
## PASSWD file. Just set PASSWD to the full path and USERS to your
## users location. Then make script executable with chmod 755 or so.
## After that, just run it from time to time to check.
## (c)Turranius - 2002

PASSWD="/glftpd/etc/passwd"
USERS="/glftpd/ftp-data/users"

########################################

echo "--[ Checking that all users in passwd exists as userfiles ]--"
for line in `cat $PASSWD | awk -F":" '{print $1}'`; do
  if [ -e $USERS/$line ]; then
    yes=yes
  else
    echo "$line has a passwd entry, but no userfile."
    foundone="YES"
  fi
done
if [ "$foundone" != "YES" ]; then
  echo "All users in passwd file has a userfile"
fi

echo "--[ Checking that all user files exist in the passwd ]--"

foundone=""
cd $USERS
for each in `grep FLAGS * | grep -v default.user | awk -F":" '{print $1}'`; do
  VERIFY=""
  VERIFY="$( cat $PASSWD | grep -w $each )"
  if [ "$VERIFY" = "" ]; then
    echo "$each has a userfile, but no passwd entry."
    foundone="YES"
  fi
done
if [ "$foundone" != "YES" ]; then
  echo "All userfiles match a user in passwd file"
fi